<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs-target-android.qdoc -->
  <title>Building for Android | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Building for Android</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#creating-android-application-packages">Creating Android Application Packages</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Building for Android</h1>
<span class="subtitle"></span>
<!-- $$$qbs-target-android.html-description -->
<div class="descr"> <a name="details"></a>
<p>To develop applications for Android, you need development tools provided by the Android SDK from Google, and (optionally) a C/C++ toolchain provided by the Android NDK.</p>
<p><b>Note: </b>Qbs does not yet support the Kotlin programming language.</p><a name="creating-android-application-packages"></a>
<h2 id="creating-android-application-packages">Creating Android Application Packages</h2>
<p>On Android, applications are distributed in a specially structured type of ZIP package called an APK. The following files should be created and bundled into an APK:</p>
<ul>
<li>Android assets.</li>
<li>Android resource files.</li>
<li>AndroidManifest.xml, which provides meta-information about your application.</li>
<li>Compiled Java code, which serves as the entry point into your application and that automatically executes the native code in your application (if there is any).</li>
<li>Shared libraries containing native code.</li>
</ul>
<p>You can use the <a href="qml-qbsconvenienceitems-application.html">Application</a> item to build application packages for Android.</p>
<p>If the <a href="qml-qbsmodules-qbs.html#targetPlatform-prop">target platform</a> is <code>&quot;android&quot;</code>, then the Application item has a dependency on the <a href="qml-qbsmodules-android-sdk.html">Android.sdk</a> module, which contains the properties and rules to create Android application packages from source files.</p>
<p>You can use the <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a> item to build native Android libraries that are bundled into the APK. The <code>qbs.architectures</code> property specifies the architectures to build for, with the default value <code>armv7a</code>. If you have only one native library, you can simply list its sources within the main Application item, and it will get built and packaged automatically.</p>
<p>The <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a> item, as well as the <a href="qml-qbsconvenienceitems-cppapplication.html">CppApplication</a> item, has a dependency on the <a href="qml-qbsmodules-android-ndk.html">Android.ndk</a> module, and contains the properties and rules to create native libraries.</p>
</div>
<!-- @@@qbs-target-android.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
